<template lang="pug">

.login-public.container(v-loading="loginLoad")
  .block-typical

    .login__header(
      v-if="!viewRegistration")
      h1 Авторизация

    .login__header(
      v-if="viewRegistration")
      h1 Регистрация

    el-form(
      v-if="stateForm"
      ref='loginForm'
      :model='stateForm'
      :rules="rules")

      el-form-item(
        v-for="item in loginForm"
        :key="item.id"
        :prop="item.name")

        app-input(
          :placeholder="item.placeholder"
          :model="item.model"
          :name="item.name"
          :id="item.id"
          :submitFunc="onSubmit"
          :type="item.type"
          :label="item.label"
          :required="item.required"
          :formRef="'loginForm'"
          @input-value="modelValue")

    <!--nuxt-link.reset-link(-->
      <!--v-if="!viewRegistration"-->
      <!--:style="actionLinkStyle"-->
      <!--to="/reset-password") Забыли пароль?-->

    .login__buttons-wrapper
      .button-wrapper
        button.nuxt-button-link(
          v-if="!viewRegistration"
          @click="onSubmit('loginForm')"
          :disabled="!buttonConditionDisabled")
          |Войти

      .button-wrapper
        button.nuxt-button-link(
          v-if="viewRegistration"
          @click="createUser('loginForm')"
          :disabled="!buttonConditionDisabled")
          |Зарегестрироваться

      el-button.registration-button(
        v-if="!viewRegistration"
        type="text"
        :style="actionButtonStyle"
        @click="toggleRegistration('loginForm')") Зарегестрироваться

      el-button(
        v-if="viewRegistration"
        type="text"
        :style="actionButtonStyle"
        @click="toggleRegistration('loginForm')") Вернуться к авторизации
</template>

<script>
import { mapMutations } from 'vuex';

import InputItem from '../../components/InputItem';
import * as Cookies from 'js-cookie';

export default {
  name: 'Login',
  components: {
    'app-input': InputItem
  },
  head() {
    return {
      title: 'Вход | АО «Шувалово»'
    };
  },
  data() {
    return {
      loginLoad: false,
      loginForm: [
        {
          id: 1,
          placeholder: 'Ведите email',
          model: '',
          label: 'Email',
          required: true,
          name: 'login',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите email',
              trigger: 'change'
            },
            {
              type: 'email',
              message: 'Пожалуйста, укажите верный email',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: 'Не менее 6-ти символов',
          model: '',
          label: 'Пароль',
          required: true,
          name: 'password',
          type: 'password',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите пароль',
              trigger: 'change'
            },
            { min: 6, message: 'Пароль не менее 6 символов', trigger: 'change' }
          ]
        }
      ],
      actionLinkStyle: {
        'margin-bottom': '15px'
      },
      actionButtonStyle: {
        'margin-top': '10px'
      },
      viewRegistration: false
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.loginForm.forEach(item => {
        state[item.name] = item.model;
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.loginForm.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    },
    buttonConditionDisabled() {
      let keys = Object.keys(this.stateForm);
      let stateFormInputFull = [];
      keys.forEach(key => {
        if (this.stateForm[key].length) {
          stateFormInputFull.push(true);
        } else if (stateFormInputFull.length) {
          stateFormInputFull.pop();
        }
      });
      return stateFormInputFull.length
        ? keys.length === stateFormInputFull.length
        : false;
    }
  },
  mounted() {
    this.SET_LOADING(false);
  },
  methods: {
    ...mapMutations(['SET_LOADING']),
    toggleRegistration(formName) {
      this.viewRegistration = !this.viewRegistration;
      this.$refs[formName].clearValidate();
    },
    modelValue(valueArr) {
      let index = this.loginForm.findIndex(item => item.id === valueArr[0]);
      this.loginForm[index].model = valueArr[1];
      this.stateForm[this.loginForm[index].name] = valueArr[1];
    },
    onSubmit(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.loginLoad = true;
          this.$axios
            .post('/api/v1/login', {
              email: this.stateForm.login,
              password: this.stateForm.password
            })
            .then(
              response => {
                this.setUser(response);
                this.loginLoad = false;
                this.$message.success('Успешная авторизация в системе!');
                this.$router.push({ path: '/' });
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error(
                  'Неверный логин или пароль! Проверьте правильность вводимых данных.'
                );
                this.loginLoad = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка проверки подлинности пользователя!');
              this.loginLoad = false;
            });
        } else {
          this.$message.error(
            'Пожалуйста, заполните форму авторизации корректно!'
          );
          return false;
        }
      });
    },
    createUser(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.loginLoad = true;
          this.$axios
            .post('/api/v1/users/', {
              email: this.stateForm.login,
              password: this.stateForm.password,
              role: 'user',
              active: true
            })
            .then(
              response => {
                this.setUser(response);
                this.loginLoad = false;
                this.$router.push('/');
                this.$message.success('Успешная регистрация!');
              },
              () => {
                this.loginLoad = false;
                this.$message.error(
                  'Пользователь с такой почтой уже существует!'
                );
              }
            )
            .catch(() => {
              this.$message.error('Ошибка регистрации!');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    },
    setUser(response) {
      Cookies.set('__a_t', response.data.cookies.access_token);
      Cookies.set('__r_t', response.data.cookies.refresh_token);
      this.$store.commit('userAuth', true);
      this.$store.commit('user', response.data.user);
      if (response.data.user.role === 'admin') {
        this.$store.commit('adminAuth', true);
      }
    }
  }
};
</script>
